#include "userprog/syscall.h"
#include <stdio.h>
//#include <string.h>
#include <syscall-nr.h>
#include "threads/interrupt.h"
#include "threads/thread.h"
#include <devices/shutdown.h>
#include "threads/init.h"
#include "filesys/filesys.h"
#include "lib/user/syscall.h"
#include "filesys/file.h"
#include "threads/synch.h"
#include <stdlib.h>
#include "threads/vaddr.h"
#include "threads/vaddr.h"


struct file* process_get_file (int fd); // FOR READ
void halt (void) NO_RETURN;
void exit (int status) NO_RETURN;
pid_t exec (const char *file);
int wait (pid_t pid);
bool create (const char *file, unsigned initial_size);
bool remove (const char *file);
int open (const char *file);
int filesize (int fd);
int read (int fd, void *buffer, unsigned length);
int write (int fd, const void *buffer, unsigned length);
void seek (int fd, unsigned position);
unsigned tell (int fd);
void close (int fd);
static int32_t usergrab (const uint8_t *uaddr);
int input_getc (void); // for read 


struct file_descriptor
  {
    int fd;
    struct file *file;
    struct list_elem elem;
  };

struct process_file
  {
    int fd;
    struct file *file;
    struct list_elem elem;
  };




void strcpy(char *dest, const char *src) 
{
    int i = 0;
    while ((dest[i] = src[i]) != '\0')
    {
        i++;
    } 
}

void strcpytest()
{
    char a;
    char b;
    a = ("letsgetit");
    b = ("empty");
    printf(a);
    printf(b);
    strcpy(b, a);
    printf(a);
    printf(b);
}

static int
scanmem (void *src, void *dst, size_t bytes)
{
  int32_t value;
  size_t i;
  for(i=0; i<bytes; i++) {
    value = usergrab(src + i);


    *(char*)(dst + i) = value & 0xff;
  }
  return (int)bytes;
}

//GET USER CODE 
static int32_t
usergrab (const uint8_t *uaddr) {
  // check that a user pointer `uaddr` points below PHYS_BASE
  if (! ((void*)uaddr < PHYS_BASE)) {
    return -1;
  }

  // as suggested in the reference manual, see (3.1.5)
  int result;
  asm ("movl $1f, %0; movzbl %1, %0; 1:"
      : "=&a" (result) : "m" (*uaddr));
  return result;
}

bool 
create (const char *file, unsigned initial_size)
{
  printf("file: %s\n", file);
  printf("initial size: %d\n", initial_size);
  printf("File generated succsessfully!");
  //char str[20] = "fresh2refresh.com";
  //char target[25] ="ello";
  //printf("\n %s \n", str); 
  //printf("%s \n", target);
  //strcpy(target, str);
  //printf("%s \n", str);
  //printf("%s \n", target);

  return filesys_create (file, initial_size);

}

bool remove(const char* filename) {
  //bool return_code;
  char buf [100];
  // memory validation missing no check user function // added now
  
  printf ("CHECK USER RUN\n");
  strcpy (buf, filename);
  
  printf ("File removed --->");
  printf (buf);
  filesys_remove(buf);
}


static void syscall_handler (struct intr_frame *);

static uint32_t load_stack(struct intr_frame *f, int offset){
  return *((uint32_t*)(f->esp + offset));
}


void
syscall_init (void) 
{
  intr_register_int (0x30, 3, INTR_ON, syscall_handler, "syscall");
}

struct file* //GET FILE FUNCTION 
process_get_file (int fd)
{
  struct thread *t = thread_current ();

  if (fd < 0 || fd >= 128)
    return NULL;

  return t->fd_table[fd];
}

static void
syscall_handler (struct intr_frame *f){
  int code = (int)load_stack(f, 0);
  switch (code){
    case SYS_HALT:
            printf("SYSTEM HALT CALL RUN SUCCSESSFULLY \n");
            shutdown_power_off();
            break;
    case SYS_EXIT:
            printf("EXIT DONE");
            break;

    case SYS_READ:
    {

    }
    case SYS_CREATE:
    {
            const char *file;
            unsigned initial_size;
            scanmem (f->esp + 4, &file, sizeof file);
            scanmem (f->esp + 8, &initial_size, sizeof initial_size);
            f->eax = create (file, initial_size);
            break;
    }
    case SYS_WAIT: 
    {

    }
    case SYS_REMOVE:
    {
            const char* filename;
            bool return_code;

            scanmem(f->esp + 4, &filename, sizeof(filename));
            
            return_code = remove(filename);
            f->eax = return_code;
            break;



    }        


  }



thread_exit ();
}
    

